## virtualbox-ose 2.0.4-dfsg-0ubuntu1

=== debian/virtualbox-ose-guest-source.files/Makefile ===
obj-m = vboxadd/ vboxvfs/
