=== debian/changelog ===
virtualbox-ose (2.0.4-dfsg-0ubuntu1) intrepid; urgency=low

  [ Jonathan Ernst ]
  * Virtualbox should go in Accessories, not in System tools (LP: #288590) 

  [ Daniel Hahler ]
  * New upstream version (LP: #288957)
    - Updated debian/patches/09-initscript.dpatch (one hunk rejected/obsolete)
  * Drop debconf question about losing snapshots because of upgrading: it is
    no longer relevant and the default (cancel upgrade) caused a lot of
    trouble (LP: #288178, #221736)
    - debian/virtualbox-ose.preinst.in, debian/virtualbox-ose.templates,
      debian/rules
  * Improve patch for disabling the "check for updates" dialog (LP: #272212)
    - debian/patches/13-disable-update-action.dpatch
  * Disable registration request at Sun (LP: #285684, #271603)
    - debian/patches/14-disable-registration-request.dpatch

 -- Daniel Hahler <ubuntu@thequod.de>  Sun, 26 Oct 2008 02:23:42 +0100

virtualbox-ose (2.0.2-dfsg-0ubuntu3) intrepid; urgency=low

  * debian/patches/13-disable-update-action.dpatch:
    Disable update action menu entry (LP: #272212)

 -- Daniel Hahler <ubuntu@thequod.de>  Fri, 19 Sep 2008 23:33:32 +0200

virtualbox-ose (2.0.2-dfsg-0ubuntu2) intrepid; urgency=low

  * debian/virtualbox-ose.install:
    - Install VBoxHeadless (LP: #271753)
  * debian/virtualbox-ose.links:
    - Include symlink for VBoxHeadless
  * debian/virtualbox-ose.files/VBox.sh:
    - Remove check for vboxusers, not necessary w/
      hardening.
  * debian/virtualbox-ose.udev:
    - Don't set vboxdrv to vboxusers, not necessary
      w/ hardening.
  * debian/virtualbox-ose.vboxdrv.init:
    - Remove permissions check for vboxdrv.
  * debian/rules:
    - Enable 64 bit guest support when building on 
      AMD64 (LP: #271651)
    - Set VBoxHeadless suid.
  * debian/control:
    - Add depends for linux-headers to make sure
      that the modules can compile initially (LP: #271534)

 -- Mario Limonciello <mario_limonciello@dell.com>  Thu, 18 Sep 2008 12:49:02 -0500

virtualbox-ose (2.0.2-dfsg-0ubuntu1) intrepid; urgency=low

  * New upstream version (LP: #268795)
    - Introduces support for Intrepid Guests
    - Introduces support for kernel 2.6.27
  * Update patches for new upstream version:
    - 02-config-kmk
    - 09-initscript
  * Drop patches no longer necessary (or absorbed upstream):
    - 05-vboxadd-udev
    - 01-no-64bit-guest
  * New patches:
    - 01-64bit, for making sure we query the target arch properly.
  * debian/control:
    - Build depend on libqt4-dev for new upstream version.
    - Build depend on python2.5-dev for new upstream version.
    - Drop libqt3-mt-dev from build depends
    - Bump provides of guest-utils to xserver-xorg-input-2.1
    - Bump provides of guest-utils to xserver-xorg-video-2.9
    - Enable 64 bit guest utils support.
  * debian/rules:
    - Disable QT3 support as we are using the QT4 frontend by
      default.
    - Set VirtualBox binaries to suid root per new hardening
      requirements in this release.
    - Add amd64 to a valid arch in the X11 additions check.
  * debian/virtualbox-ose.install:
    - Update location that xpidl is installed from.
  * debian/virtualbox-ose.vboxdrv.init:
    - Start at runlevels 2,3,4,5 rather than just 3,5
  * Enable DKMS support on virtualbox host and guest modules. (LP: #267097)
    - Rebuilding is no longer necessary for new kernels (LP: #268367)
    - Drop:
      + virtualbox-ose-source.files/rules
      + virtualbox-ose-source.files/postinst.modules.in
      + virtualbox-ose-source.files/control.modules.in
      + virtualbox-ose-guest-source.files/rules
      + virtualbox-ose-guest-source.files/postinst.modules.in
      + virtualbox-ose-guest-source.files/control.modules.in
      + virtualbox-ose-source.links
    - Rename / Add version to .in files:
      + virtualbox-ose-guest-source.files/udev -> 
        virtualbox-ose-guest-source.udev
      + virtualbox-ose-guest-source.install -> 
        virtualbox-ose-guest-source.install.in
      + virtualbox-ose-source.dirs -> virtualbox-ose-source.dirs.in
      + virtualbox-ose-guest-source.dirs -> virtualbox-ose-guest-source.dirs.in
      + virtualbox-ose-guest-source.links -> 
        virtualbox-ose-guest-source.links.in
    - New:
      + virtualbox-ose-source.files/dkms.conf.in
      + virtualbox-ose-source.postinst
      + virtualbox-ose-source.prerm
      + virtualbox-ose-guest-source.prerm
      + virtualbox-ose-guest-source.postinst
      + virtualbox-ose-guest-source.files/dkms.conf.in
      + virtualbox-ose-guest-source.files/Makefile
    - debian/rules:
      + Add support to update all ".in" files in install target
      + Add support to remove all sed produced ".in" files in clean target
      + Drop extra rules that were modifying the "debian" directory in -source.
      + Make sure to include postinst/prerm scripts for arch indep packages.
    - debian/control:
      + Recommends on the source package instead of modules packages
      + Depends on the source packages for dkms and libc6-dev
    - debian/virtualbox-ose.vboxdrv.init:
      + Search for module in proper location

 -- Mario Limonciello <mario_limonciello@dell.com>  Wed, 10 Sep 2008 13:50:20 -0500

virtualbox-ose (1.6.2-dfsg-1ubuntu2) intrepid; urgency=low

  * Fix dpatch 01-no-64bit-guest to change upstream's uname -m into
    dpkg-architecture -qDEB_HOST_GNU_CPU instead of dpkg --print-architecture;
    fixes build on lpia.
  * Build virtualbox-ose, virtualbox-ose-dbg, and virtualbox-ose-guest-utils
    for lpia.
  * Set VBOX_WITH_X11_ADDITIONS in rules when the DEB_HOST_ARCH is i386 or
    lpia instead of using dpkg --print-architecture.
  * Use the -s flag to dh_ commands instead of 3 debhelper calls and a shell
    test; as a bonus, this provides additional detached symbols in -dbg.
  * Install files into virtualbox-ose-guest-utils unconditionally and ignore
    errors -- even if these exist, the package is disabled on amd64.
  * Cleanup upstreamversion computation and compute it only once.

