=== debian/control ===
Source: virtualbox-ose
Section: misc
Priority: extra
Maintainer: Ubuntu MOTU Developers <ubuntu-motu@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Virtualbox Team <pkg-virtualbox-devel@lists.alioth.debian.org>
Uploaders: Philipp Hug <debian@hug.cx>, Marvin Stark <marv@der-marv.de>, Michael Meskes <meskes@debian.org>, Patrick Winnertz <winnie@debian.org>, Daniel Baumann <daniel@debian.org>, Hilko Bengen <bengen@debian.org>
Build-Depends: debhelper (>= 5.0.44~), dpatch, bcc, bzip2, g++-4.2-multilib [amd64], iasl, kbuild, libacl1-dev, libasound-dev, libhal-dev, libidl-dev, libsdl1.2-dev, libxslt1-dev, uuid-dev, yasm (>= 0.7.0), libpulse-dev, po-debconf (>= 0.5.0), docbook-xsl, xsltproc, lynx, docbook-xml, gcc-4.2, g++-4.2, libqt4-dev, python2.5-dev
Standards-Version: 3.8.0
Homepage: http://www.virtualbox.org/
XS-Original-Vcs-Svn: svn://svn.debian.org/svn/pkg-virtualbox/trunk
XS-Original-Vcs-Browser: http://svn.debian.org/wsvn/pkg-virtualbox/trunk

Package: virtualbox-ose
Architecture: amd64 i386 lpia
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Pre-Depends: debconf | debconf-2.0
Recommends: virtualbox-ose-source
Suggests: bridge-utils
Conflicts: virtualbox
Replaces: virtualbox
Provides: virtualbox
Description: x86 virtualization solution - binaries
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the binaries for the Open Source Edition of
 VirtualBox. The virtualbox-ose-source package is also required in order to
 compile the kernel modules needed for virtualbox-ose.

Package: virtualbox-ose-dbg
Section: devel
Priority: extra
Architecture: amd64 i386 lpia
Depends: virtualbox-ose (= ${binary:Version})
Description: x86 virtualization solution - debugging symbols
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the debugging symbols for the Open Source Edition of
 VirtualBox.

Package: virtualbox-ose-source
Architecture: all
Depends: dkms, libc6-dev, linux-headers-generic | linux-headers
Conflicts: virtualbox-source
Replaces: virtualbox-source
Provides: virtualbox-source
Description: x86 virtualization solution - kernel module source
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the source code for the virtualbox kernel module.
 The virtualbox-ose package is also required in order to make use of these
 modules. Kernel sources or headers are required to compile this module.

Package: virtualbox-ose-guest-source
Architecture: all
Depends: dkms, libc6-dev, linux-headers-generic | linux-headers
Description: x86 virtualization solution - guest addition module source
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the source code for the virtualbox guest addition kernel
 modules. The virtualbox-ose-guest-utils package is also required in order to
 make use of these modules. Kernel sources or headers are required to compile
 these modules.

Package: virtualbox-ose-guest-utils
Architecture: i386 lpia amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, pciutils
Conflicts: xserver-xorg-core (< 2:1.4)
Recommends: virtualbox-ose-guest-modules, xserver-xorg-core (>= 2:1.4)
Suggests: virtualbox-ose-guest-source
Provides: xserver-xorg-video-2.9, xserver-xorg-input-2.1
Description: x86 virtualization solution - guest utilities
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the guest utilities of the Open Source Edition of
 VirtualBox. These utilities are meant to be run inside the virtual machine.
 They provide closer integration (e.g. mouse pointer, time synchronization),
 improve the interactive performance (e.g. better video support), and allow to
 share data through shared folders between the host system and the virtual
 machine.
