=== src/VBox/HostDrivers/Support/linux/Makefile ===
--- 
+++ 
@@ -66,34 +66,39 @@
  $(warning Using BUILD_TYPE='$(BUILD_TYPE)' from the $(origin BUILD_TYPE).)
 endif
 
+# use vm_insert_page() API (if available) to map kernel pages to userland - better debugging 
+# VBOX_USE_INSERT_PAGE = 1
 
 # override is required by the Debian guys
 override MODULE = vboxdrv
 OBJS   = \
 	linux/SUPDrv-linux.o \
-	SUPDRVShared.o \
+	SUPDrv.o \
 	r0drv/alloc-r0drv.o \
 	r0drv/initterm-r0drv.o \
-	r0drv/linux/mp-r0drv-linux.o \
+	r0drv/memobj-r0drv.o \
+	r0drv/mpnotification-r0drv.o \
+	r0drv/powernotification-r0drv.o \
+	r0drv/linux/assert-r0drv-linux.o \
 	r0drv/linux/alloc-r0drv-linux.o \
 	r0drv/linux/initterm-r0drv-linux.o \
+	r0drv/linux/memobj-r0drv-linux.o \
+	r0drv/linux/mp-r0drv-linux.o \
+	r0drv/linux/mpnotification-r0drv-linux.o \
 	r0drv/linux/process-r0drv-linux.o \
 	r0drv/linux/semevent-r0drv-linux.o \
 	r0drv/linux/semeventmulti-r0drv-linux.o \
 	r0drv/linux/semfastmutex-r0drv-linux.o \
 	r0drv/linux/spinlock-r0drv-linux.o \
-	r0drv/linux/thread-r0drv-linux.o
-ifeq ($(BUILD_TARGET_ARCH),amd64)
-OBJS  += alloc/heapsimple.o
-endif
-ifeq ($(BUILD_TYPE),debug)
-OBJS  += \
-	math/gcc/divdi3.o \
-	math/gcc/moddi3.o \
-	math/gcc/udivdi3.o \
-	math/gcc/umoddi3.o \
-	math/gcc/qdivrem.o \
+	r0drv/linux/thread-r0drv-linux.o \
+	r0drv/linux/thread2-r0drv-linux.o \
+	r0drv/linux/time-r0drv-linux.o \
+	r0drv/linux/timer-r0drv-linux.o \
+	common/err/RTErrConvertFromErrno.o \
 	common/log/log.o \
+	common/log/logellipsis.o \
+	common/log/logrel.o \
+	common/log/logrelellipsis.o \
 	common/log/logcom.o \
 	common/log/logformat.o \
 	common/string/strformat.o \
@@ -102,11 +107,22 @@
 	common/string/strprintf.o \
 	common/string/strtonum.o \
 	r0drv/linux/RTLogWriteDebugger-r0drv-linux.o \
+	generic/RTAssertShouldPanic-generic.o \
 	generic/RTLogWriteStdErr-stub-generic.o \
 	generic/RTLogWriteStdOut-stub-generic.o \
 	generic/RTLogWriteUser-generic.o \
 	VBox/log-vbox.o \
 	VBox/strformat-vbox.o
+ifeq ($(BUILD_TARGET_ARCH),x86)
+OBJS += math/gcc/divdi3.o \
+	math/gcc/moddi3.o \
+	math/gcc/qdivrem.o \
+	math/gcc/udivdi3.o \
+        math/gcc/divdi3.o \
+	math/gcc/umoddi3.o
+endif
+ifeq ($(BUILD_TARGET_ARCH),amd64)
+OBJS += alloc/heapsimple.o
 endif
 
 ifneq ($(MAKECMDGOALS),clean)
@@ -189,6 +205,8 @@
 $(warning dbg: KERN_VERSION = $(KERN_VERSION))
 endif
 
+KBUILD_VERBOSE ?= 1
+
 #
 # Compiler options
 #
@@ -200,7 +218,7 @@
  INCL    += $(addprefix -I$(KBUILD_EXTMOD),/ /include /r0drv/linux)
  export INCL
 endif
-KFLAGS   := -D__KERNEL__ -DMODULE -DRT_OS_LINUX -DIN_RING0 -DIN_RT_R0 -DIN_SUP_R0 -DVBOX -DRT_WITH_VBOX
+KFLAGS   := -D__KERNEL__ -DMODULE -DRT_OS_LINUX -DIN_RING0 -DIN_RT_R0 -DIN_SUP_R0 -DVBOX -DRT_WITH_VBOX -DVBOX_WITH_HARDENING
 ifdef VBOX_REDHAT_KABI
  KFLAGS  += -DVBOX_REDHAT_KABI
 endif
@@ -212,35 +230,29 @@
 else
  KFLAGS  += -DRT_ARCH_X86
 endif
+# must be consistent with Config.kmk!
+KFLAGS  += -DVBOX_WITH_64_BITS_GUESTS
 ifeq ($(BUILD_TYPE),debug)
- KFLAGS  += -DDEBUG -DDEBUG_$(USER)
+ KFLAGS  += -DDEBUG -DDEBUG_$(USER) -g
  # IPRT_DEBUG_SEMS indicates thread wrt sems state via the comm field.
  KFLAGS  += -DIPRT_DEBUG_SEMS
 endif
 
-#
-# Use the RTR0MemObj API - testing.
-# If this makes testboxes crash/burn/leak disable it and add a comment to defect #2116.
-#
-KFLAGS += -DUSE_NEW_OS_INTERFACE_FOR_MM
-OBJS += r0drv/memobj-r0drv.o \
-	r0drv/linux/memobj-r0drv-linux.o
-ifeq ($(BUILD_TARGET_ARCH),x86) # Some gcc versions ends up needing __divdi3.
-OBJS += math/gcc/qdivrem.o \
-	math/gcc/divdi3.o
-endif
-
-ifeq ($(KERN_VERSION), 24)
-# 2.4
-TOPDIR         = $(KERN_DIR)
-MODULE_EXT    := o
-EXTRA_CFLAGS  := -DVBOX_LINUX_2_4
-$(MODULE)-objs = $(OBJS)
-else
+# By default we use remap_pfn_range() kernel API to make kernel pages
+# visible for userland. Unfortuately, it leads to situation that
+# during debug session all structures on that page (such as PVM pointer)
+# are not accessible to the debugger (see #3214).
+# This code enables experimental support
+# for vm_insert_page() kernel API, allowing to export kernel pages
+# to the userland in more debugger-friendly way. Due to stability
+# concerns, not enabled by default yet.
+ifdef VBOX_USE_INSERT_PAGE
+ KFLAGS  += -DVBOX_USE_INSERT_PAGE
+endif
+
 # 2.6 and later
 MODULE_EXT    := ko
 $(MODULE)-y   := $(OBJS)
-endif
 
 # build defs
 EXTRA_CFLAGS  += $(INCL) $(KFLAGS) $(KDEBUG)
@@ -250,18 +262,7 @@
 obj-m += $(MODULE).o
 
 $(MODULE):
-	$(MAKE) KBUILD_VERBOSE=1 -C $(KERN_DIR) SUBDIRS=$(CURDIR) SRCROOT=$(CURDIR) modules
-
-ifeq ($(KERN_VERSION), 24)
-#
-# 2.4 Module linking
-#
-$(MODULE).o: $(OBJS)
-	$(LD) -o $@ -r $(OBJS)
-
-include $(KERN_DIR)/Rules.make
-
-endif
+	$(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) -C $(KERN_DIR) SUBDIRS=$(CURDIR) SRCROOT=$(CURDIR) modules
 
 install: $(MODULE)
 	@mkdir -p $(MODULE_DIR); \
@@ -276,6 +277,6 @@
 endif # eq($(MAKECMDGOALS),clean)
 
 clean:
-	for f in . linux r0drv r0drv/linux VBox common/string common/log generic math/gcc; \
+	for f in . linux r0drv r0drv/linux VBox common/err common/string common/log generic math/gcc; \
 	    do rm -f $$f/*.o $$f/.*.cmd $$f/.*.flags; done
-	rm -rf .vboxdrv* .tmp_ver* vboxdrv.* Module.symvers Modules.symvers
+	rm -rf .vboxdrv* .tmp_ver* vboxdrv.* Module.symvers Modules.symvers modules.order
